/********************************
	Satelite Flasher by neur0n


*********************************/

#include <pspsdk.h>
#include <pspkernel.h>
#include <pspctrl.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>

#include "include/satelitem33.h"
#include "include/satelite.h"
#include "include/sateliteGEN.h"
#include "include/satelitePro.h"
#include "include/satelite503.h"


PSP_MODULE_INFO("SateliteFlasher", 0x0800, 1, 0); 
PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_VSH);

#define printf pspDebugScreenPrintf
#define RED 0x111FFF
#define WHITE 0xFFFFF1
#define GREEN 0x0000FF00

char msg[256];
//int cbid;
//int thid;

////////////////////////////////////////
/*
int exit_callback(int arg1, int arg2, void *common) 
{
    sceKernelExitGame();
	return 0; 
}
int CallbackThread(SceSize args, void *argp) 
{
    cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
    sceKernelRegisterExitCallback(cbid);
    sceKernelSleepThreadCB();
	return 0; 
}
int SetupCallbacks(void) 
{
    thid = 0;
    thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, THREAD_ATTR_USER, 0);
    if (thid >= 0)
	sceKernelStartThread(thid, 0, 0);
    return thid; 
}
*/
////////////////////////////////////////
void ErrorExit(int milisecs, char *fmt, ...) 
{
	va_list list;
	va_start(list, fmt);
	vsprintf(msg, fmt, list);
	va_end(list);
	printf(msg);
	sceKernelDelayThread(milisecs*1000);
	sceKernelExitGame(); 
}
////////////////////////////////////////
int flash_file(char *file, void *file_name,  int file_size) 
{
	int written;
	SceUID fd;

    printf("Writing File %s.... ", file);
    fd = sceIoOpen(file, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC , 511 );
    if(fd < 0)
	{
          pspDebugScreenSetTextColor(RED);
          ErrorExit(5000, "\n\nCannot open file for writing.\n"); 
	}

    written = sceIoWrite(fd, file_name, file_size);
    if(written != file_size) 
	{
		sceIoClose(fd);     
		pspDebugScreenSetTextColor(RED);
		ErrorExit(5000, "\n\nCannot write file.\n"); 
	}
    sceIoClose(fd);
    printf("OK\n\n");
    return 0;
}
////////////////////////////////////////
void remove_files(char *files) {
     printf("Removing File %s....", files);
     sceIoRemove(files);
     printf("OK\n"); }

int Assign()
{
	if (sceIoUnassign("flash0:") < 0)
		return -1;
	
	if (sceIoAssign("flash0:", "lflash0:0,0", "flashfat0:", IOASSIGN_RDWR, NULL, 0) < 0)
		return -1;

	return 0;
}
////////////////////////////////////////
int main() 
{
	int devkit;

	pspDebugScreenInit();
	pspDebugScreenSetTextColor(WHITE);

//	SetupCallbacks();

	devkit = sceKernelDevkitVersion();

	/*
	if(devkit =< 0x05000000) 
	{
		ErrorExit(5000,"FW ERROR!\n");
	}
    */

	printf("\nCustom Satelite Flasher v1.2 for 5.00M33, 5.50GEN by neur0n.\n\n\n");
	printf("Press X to install Custom VSH Menu.\nPress UP to install 5.03 Custom VSH Menu. \n\n");
    printf("Press /_\\ to restore GEN VSH Menu.\n");
    printf("Press [] to restore M33 VSH Menu. \nPress DOWN to restore 5.03Prometheus VSH Menu.\n\nPress R to exit.\n\n");
    
	while (1)
	{
        SceCtrlData pad;
        sceCtrlReadBufferPositive(&pad, 1);

		if (pad.Buttons & PSP_CTRL_CROSS)
		{
			if(Assign()<0)
				ErrorExit(5000,"Error in assign.\n");
			flash_file("flash0:/vsh/module/satelite.prx", sateliteC , sateliteC_size );
			break; 

		}else if (pad.Buttons &  PSP_CTRL_UP)
		{
			if(Assign()<0)
				ErrorExit(5000,"Error in assign.\n");
			flash_file("flash0:/vsh/module/satelite.prx", satelitePro , satelitePro_size );
			break; 

		}else if (pad.Buttons &  PSP_CTRL_DOWN)
		{
			if(Assign()<0)
				ErrorExit(5000,"Error in assign.\n");
			flash_file("flash0:/vsh/module/satelite.prx", satelite503 , satelite503_size );
			break; 

		}else if (pad.Buttons & PSP_CTRL_SQUARE )
		{
			if(Assign()<0)
				ErrorExit(5000,"Error in assign.\n");
			flash_file("flash0:/vsh/module/satelite.prx", sateliteM33 , sateliteM33_size );
			break; 

		}else if (pad.Buttons & PSP_CTRL_TRIANGLE )
		{
			if(Assign()<0)
				ErrorExit(5000,"Error in assign.\n");
			flash_file("flash0:/vsh/module/satelite.prx", sateliteGEN , sateliteGEN_size );
			break; 

		}else if (pad.Buttons & PSP_CTRL_RTRIGGER)
		{
			ErrorExit(2000,"Cancelled by user.\n");
		}

		sceKernelDelayThread(10000);
	}
		

		ErrorExit(5000,"\nInstall complete. Restarting in 5 seconds...\n");

	return 0;
}
//